package classify

import (
	"hongze/hongze_yb/global"
	"hongze/hongze_yb/utils"
)

func GetAll()(list []*Classify, err error)  {
	err = global.MYSQL["rddp"].Model(Classify{}).Scan(&list).Error
	return
}

func GetSimpleAll()(list []*Classify, err error)  {
	err = global.MYSQL["rddp"].Select("id, classify_name, yb_icon_url, yb_bg_url, parent_id").Model(Classify{}).Scan(&list).Error
	return
}
// GetByClassifyName 根据分类名称查找专栏详情
func GetByClassifyName(classifyName string) (item *Classify, err error) {
	err = global.MYSQL["rddp"].Model(Classify{}).Where("classify_name = ?", classifyName).First(&item).Error
	if err == utils.ErrNoRow {
		err = nil
	}
	return
}

// GetSecondIdsByClassifyNames 根据权限相关的二级分类名称获取名称ID
func GetSecondIdsByClassifyNames(names []string) (ids []int, err error) {
	var list []*Classify
	err = global.MYSQL["rddp"].Model(Classify{}).Select("id").Where("classify_name in (?) and parent_id >0 ", names).Scan(&list).Error
	if err != nil {
		if err == utils.ErrNoRow {
			err = nil
		}
		return
	}
	for _, v := range list {
		ids = append(ids, v.Id)
	}
	return
}

// GetParentList 查询所有一级分类
func GetParentList() (list []*Classify, err error) {
	err = global.MYSQL["rddp"].Model(Classify{}).Where("parent_id = 0 and classify_name != '权益研报'").Order("sort asc, id asc").Scan(&list).Error
	if err == utils.ErrNoRow {
		err = nil
	}
	return
}

// GetByClassifyId 根据分类ID查询分类详情
func GetByClassifyId(id int) (item *Classify, err error) {
	err = global.MYSQL["rddp"].Model(Classify{}).Where("id = ?", id).First(&item).Error
	if err == utils.ErrNoRow {
		err = nil
	}
	return
}

// GetListByPid 根据分类名称查找专栏列表
func GetListByPid(pid int) (list []*Classify, err error) {
	err = global.MYSQL["rddp"].Model(Classify{}).Where("parent_id = ? ", pid).Order("sort asc, id asc").Scan(&list).Error
	if err == utils.ErrNoRow {
		err = nil
	}
	return
}

// GetIdsByClassifyName 根据分类名称查找id
func GetIdsByClassifyName(names []string) (ids []int, err error) {
	var list []*Classify
	err = global.MYSQL["rddp"].Model(Classify{}).Select("id").Where("classify_name in (?) ", names).Scan(&list).Error
	if err != nil {
		return
	}
	for _, v := range list {
		ids = append(ids, v.Id)
	}
	return
}


// GetIdsByClassifyNameAndParentId 查询
func GetIdsByClassifyNameAndParentId(names []string, parentId int) (ids []int, err error) {
	var list []*Classify
	err = global.MYSQL["rddp"].Model(Classify{}).Select("id").Where("classify_name in (?) and parent_id = ?", names, parentId).Scan(&list).Error
	if err != nil {
		return
	}
	for _, v := range list {
		ids = append(ids, v.Id)
	}
	return
}

// GetOtherIdsByClassifyNames 查询
func GetOtherIdsByClassifyNames(names []string) (ids []int, err error) {
	var list []*Classify
	err = global.MYSQL["rddp"].Model(Classify{}).Select("id").Where("classify_name in (?) and parent_id > 0", names).Scan(&list).Error
	if err != nil {
		return
	}
	for _, v := range list {
		ids = append(ids, v.Id)
	}
	return
}


// GetFirstByPid 根据一级分类查找二级分类
func GetFirstByPid(pid int) (item *Classify, err error) {
	err = global.MYSQL["rddp"].Model(Classify{}).Where("parent_id = ? ", pid).First(&item).Error
	if err == utils.ErrNoRow {
		err = nil
	}
	return
}