package report

import (
	"hongze/hongze_yb/models/tables/company"
	"hongze/hongze_yb/models/tables/rddp/report_view_record"
	"hongze/hongze_yb/services/user"
	"time"
)

func AddViewRecord(user user.UserInfo, reportId int, classifyName string, reportChapterId int) (err error) {
	companyInfo, err := company.GetByCompanyId(user.CompanyID)
	if err != nil {
		return
	}
	record := new(report_view_record.ReportViewRecord)
	record.UserId = int(user.UserID)
	record.ReportId = reportId
	record.Mobile = user.Mobile
	record.Email = user.Email
	record.RealName = user.RealName
	record.CompanyName = companyInfo.CompanyName
	record.CreateTime = time.Now()
	if classifyName == "晨报" || classifyName == "周报" {
		record.ReportChapterId = reportChapterId
	}
	err = report_view_record.Create(record)
	if err != nil {
		return
	}
	//修改联系人最后一次阅读报告时间
	err = user.WxUser.SetWxUserReportLastViewTime()
	return
}
